<nz-page-header nzBackIcon [nzTitle]="'Economy.ExchangeMarket' | translate"
  nzSubtitle="Here you can exchange currencies.">

  <nz-page-header-extra>
    <nz-button-group>
      <button nz-button nzShape="round" nzType="default" (click)="addNewOffer()"
        *ngIf="selectedBuyCurrencyId && selectedSellCurrencyId">
        {{ "Economy.Market.AddOffer" | translate }}
      </button>
      <button nz-button nzShape="round" nzType="default" (click)="showMyOffers()" *ngIf="showsOnlyMyOffers === false">
        {{ "Economy.Market.MyOffers" | translate }}
      </button>
      <button nz-button nzShape="round" nzType="default" (click)="loadOffers()"
        *ngIf="showsOnlyMyOffers === true && selectedBuyCurrencyId && selectedSellCurrencyId">
        {{ "Economy.Market.SearchedOffers" | translate }}
      </button>
    </nz-button-group>
  </nz-page-header-extra>
</nz-page-header>

<nz-spin [nzSpinning]="isLoading">
  <div nz-row nzJustify="space-around" style="text-align: center;">
    <div nz-col nzXs="23" nzSm="23" nzMd="8">
      <nz-select nzShowSearch nzAllowClear nzPlaceHolder="Currency to buy" style="width: 100%" nzSize="large"
        [nzCustomTemplate]="buyCurrencyTemplate" [(ngModel)]="selectedBuyCurrencyId"
        (ngModelChange)="selectedCurrency()">
        <nz-option *ngFor="let item of buyCurrencies" nzCustomContent [nzLabel]="item.symbol" [nzValue]="item.id">
          <img [src]="item.flagLocation" width="30" height="20" />
          {{ item.symbol | translate }}
        </nz-option>
      </nz-select>
      <ng-template #buyCurrencyTemplate>
        <img src="{{ getCurrencyData(selectedBuyCurrencyId).flagLocation }}" width="30" height="20" />
        {{ getCurrencyData(selectedBuyCurrencyId).symbol| translate }}
      </ng-template>
    </div>

    <div nz-col nzXs="23" nzSm="23" nzMd="2">
      <button nz-button (click)="switch()" nzShape="round"
       *ngIf="selectedBuyCurrencyId && selectedSellCurrencyId">
        <i class="fas fa-sync-alt"></i>
      </button>
    </div>

    <div nz-col nzXs="23" nzSm="23" nzMd="8">
      <nz-select nzShowSearch nzAllowClear nzPlaceHolder="Currency to sell" [(ngModel)]="selectedSellCurrencyId"
        nzSize="large" [nzCustomTemplate]="sellCurrencyTemplate" (ngModelChange)="selectedCurrency()"
        style="width: 100%">
        <nz-option *ngFor="let item of sellCurrencies" nzCustomContent [nzLabel]="item.symbol" [nzValue]="item.id">
          <img [src]="item.flagLocation" width="20" height="20" />
          {{ item.symbol | translate }}
        </nz-option>
      </nz-select>
      <ng-template #sellCurrencyTemplate>
        <img src="{{ getCurrencyData(selectedSellCurrencyId).flagLocation }}" width="20" height="20" />
        {{ getCurrencyData(selectedSellCurrencyId).symbol | translate }}
      </ng-template>
    </div>
  </div>

  <div style="text-align: center; margin: 20px">

    <nz-alert nzType="info" *ngIf="offers && offers.length === 0" nzMessage="{{ 'Economy.Market.noOffersCurrencies' | translate }}">
    </nz-alert>

    <div nz-row nzGutter="12" *ngIf="offers && offers.length > 0">
      <div nz-col nzXs="23" nzSm="23" nzMd="12" nzLg="8" nzXl="6" *ngFor="let offer of offers"
        style="margin-bottom: 12px;">
        <nz-card id="exchange-list-item">
          <div *ngIf="showsOnlyMyOffers === false">
            {{ "Economy.Trade.Seller" | translate }}: <a
              [routerLink]="['/', offer.owner?.type.toLowerCase(), offer.owner.id]">{{ offer.owner.name }}</a>
          </div>
          <div>{{ "Economy.Market.Amount" | translate }}: {{ offer.amount }}
            <img nz-tooltip nzTooltipTitle="{{ offer.buyCurrency.symbol | translate }}" width="20" height="20"
              src="{{ offer.buyCurrency.flagLocation }}" alt="{{ offer.buyCurrency.symbol }}" />
          </div>
          <div>
            1
            <img nz-tooltip nzTooltipTitle="{{ offer.sellCurrency.symbol | translate }}" width="20" height="20"
              src="{{ offer.sellCurrency.flagLocation }}" alt="{{ offer.sellCurrency.symbol }}" />
            = {{ offer.rate }}
            <img nz-tooltip nzTooltipTitle="{{ offer.buyCurrency.symbol | translate }}" width="20" height="20"
              src="{{ offer.buyCurrency.flagLocation }}" alt="{{ offer.buyCurrency.symbol }}" />
          </div>

          <nz-divider *ngIf="showsOnlyMyOffers === false && offer.isOwner === false || showsOnlyMyOffers === true">
          </nz-divider>
          <nz-input-group nzSearch [nzAddOnAfter]="suffixIconButton2"
            *ngIf="showsOnlyMyOffers === false && offer.isOwner === false">
            <nz-input-number [(ngModel)]="offer.selectedAmount" [nzMin]="0.00001" [nzMax]="offer.amount"
              style="width: 100%;" [nzStep]="0.1" nzPlaceHolder="Amount"></nz-input-number>
          </nz-input-group>
          <ng-template #suffixIconButton2>
            <button nz-button nzShape="round" nzType="primary" nzSearch (click)="acceptOffer(offer)">
              {{ "Economy.Trade.Buy" | translate }}
            </button>
          </ng-template>

          <span (click)="removeOffer(offer.id)" *ngIf="showsOnlyMyOffers === true" style="color: red">
            <i class="fas fa-trash"></i>
          </span>

        </nz-card>
      </div>
    </div>
  </div>
</nz-spin>

<nz-card *ngIf="chartData" nzSize="small" style="margin: 20px;"
  nzTitle="{{ 'Economy.Trade.HistoryOfOffers' | translate }}">
  <app-chart [labels]="chartData.labels" [height]="300" [datasets]="chartData.datasets" [options]="chartData.options"
    type="line">
  </app-chart>
